;Keyboard State Machine


/*
Select Map
BUS Line	KB ROM A Line	Select Type
---------------------------------------
A0			A0				0/1
KBSEL		A1				0
R/W 		A2				0/1
			Lines A3-A16 are tied low.


Memory Bit Map
--------------------------------------
Select Line		KB ROM D Line	Select Type
KEYB_OE			D0				0
KEYS_OE			D1				0
KEY_SRCLR		D2				0
				Lines D3-D7 float.


When Reading The Key Byte				
	R/W	= 1		KB_SEL = 0		A0 = 0
	Which equals ROM address: #%100	$04
	Put this on the rom bus: 11111 110
	KEY_SRCLR = 1	KEYS_OE = 1 	KEYB_OE = 0

When Reading the Status Byte
	R/W = 1		KB_SEL = 0		A0 = 1
	Which equals ROM address: #%101	$05
	Put this on the rom bus: 11111 101
	KEY_SRCLR = 1	KEYS_OE = 0 	KEYB_OE = 1


When clearing the keyboard
	R/W = 0		KB_SEL = 0		A0 = 0 or 1
	Which equals ROM address: #%000	$00
						   or #%001	$01

	Put this on the rom bus: 11111 011
	KEY_SRCLR = 0 	KEYS_OE = 1		KEYB_OE = 1
	
Note: keyboard IO space could be made more efficient by wiring the select map differently.
	I may do this at a later point.
*/


.target "65C02", 64	; We're running a 65C02 Processor
	* = $0000
	
	.byte $FB	;0000 - Clearing the keyboard
	.byte $FB	;0001 - Clearing the keyboard
	
	.byte $FF	;0002 - nothing
	.byte $FF	;0003 - nothing
	
	.byte $FE	;0004 - Reading The Key Byte
	.byte $FD	;0005 - Reading the Status Byte
	

	
	

